
///    (Brenkman Andrey)
///   20.11.2010 18.09.2011
///    99%




///!
#include "Header_constants.h"
#include "List.h"
#include "Position.h"

/// -(1-0)    
#define KONTROL_B 0 

/// 
#define TEST_H 0 



///  (bit board) 
///   Magic Bitboards

///    :
/// "Hyatt, Robert. Rotated bitmaps, a new twist on an old idea"
/// "Magic Move-Bitboard Generation in Computer Chess Pradyumna Kannan April 30, 2007"
/// chessprogramming - Magic Bitboards 
/// http://chessprogramming.wikispaces.com/Magic+Bitboards

///     Pradyumna Kannan  magicmoves.
///   

///      Position    ( List)
///            
/// +   

///              
///            

/// 
///        
///   (7.09.11) (bugs)  


///---------------------------------------------------------------------------
///    
namespace Generator_moves 
{

///   


//////////////////////////////////////////////////////////////////////////////////////
//private:




//////////////////////////////////////////////////////////////////////////////////////
//public:

	///---------------------------------------------------------------------------
	///
	void ini_attacks_magic_masks_database();

	///---------------------------------------------------------------------------
	/// 
	inline unsigned __int64 get_bishop_attacks_masks_magic
	(
		const unsigned __int8 & square,///   
		const unsigned __int64 & position_all_piece ///
	);

	///---------------------------------------------------------------------------
	/// 
	inline unsigned __int64 get_rook_attacks_masks_magic
	(
		const unsigned __int8 & square,///   
		const unsigned __int64 & position_all_piece ///
	);


//////////////////////////////////////////////////////////////////////////////////////
//private:

	///---------------------------------------------------------------------------
	///
	unsigned __int64 ini_deg_masks
	(
		const int number_on_bit[], 
		const int count_attack_squares, 
		const unsigned __int64 deg
	);

	///---------------------------------------------------------------------------
	///
	unsigned __int64 ini_rook_attacks_masks
	(
		const int square, 
		const unsigned __int64 deg_masks
	);

	///---------------------------------------------------------------------------
	///
	unsigned __int64 ini_bishop_attacks_masks
	(
		const int square, 
		const unsigned __int64 deg_masks
	);


///  

//////////////////////////////////////////////////////////////////////////////////////
//public:

	///---------------------------------------------------------------------------
	///    +   ( )
	void generator_captures_white
	(
		struct List & list,///   
		const struct Position & position ///              
	);

	///---------------------------------------------------------------------------
	///     +   ( )
	void generator_captures_black
	(
		struct List & list,///   
		const struct Position & position ///      
	);

	///---------------------------------------------------------------------------
	///     
	/// (..     +  )( )
	void generator_move_white
	(
		struct List & list,///   
		const struct Position & position ///      
	);

	///---------------------------------------------------------------------------
	///     
	/// (..     +  )( )
	void generator_move_black
	(
		struct List & list,///   
		const struct Position & position ///      
	);

	///---------------------------------------------------------------------------
	///           
	///  0    
	unsigned __int8 king_white_check
	(
		const struct Position & position ///     
	);

	///---------------------------------------------------------------------------
	///           
	///  0    
	unsigned __int8 king_black_check
	(
		const struct Position & position ///     
	);




/////////////////////////////////////////////////////////
///        


//////////////////////////////////////////////////////////////////////////////////////
//private:


	///---------------------------------------------------------------------------
	///           
	///  0    
	inline unsigned __int8 white_check_square
	(
		const unsigned __int8 & sq,///  (0-63) 
		const struct Position & position ///     
	);

	///---------------------------------------------------------------------------
	///           
	///  0    
	inline unsigned __int8 black_check_square
	(
		const unsigned __int8 & sq,///  (0-63) 
		const struct Position & position ///     
	);

	///---------------------------------------------------------------------------
	///    -   
	///        ( )
	inline void list_capture_white
	(
		struct List & list,///   
		const unsigned __int8 name,///   
		const unsigned __int8 type_move,///  
		const unsigned __int8 & from,///  
		const unsigned __int8 & to,///  
		unsigned __int8 & count,///    
		const struct Position & position ///      
	);

	///---------------------------------------------------------------------------
	///    -   
	///        ( )
	inline void list_capture_black
	(
		struct List & list,///   
		const unsigned __int8 name,///   
		const unsigned __int8 type_move,///  
		const unsigned __int8 & from,///  
		const unsigned __int8 & to,///  
		unsigned __int8 & count,///    
		const struct Position & position ///      
	);

	///---------------------------------------------------------------------------
	///   
	inline void list_record_move_white
	(
		struct List & list,///   
		const unsigned __int8 name,///   
		const unsigned __int8 type_move,///  
		const unsigned __int8 & from,///  
		const unsigned __int8 & to,///  
		unsigned __int8 & count,///    
		const struct Position & position ///      
	);

	///---------------------------------------------------------------------------
	///   
	inline void list_record_move_black
	(
		struct List & list,///   
		const unsigned __int8 name,///   
		const unsigned __int8 type_move,///  
		const unsigned __int8 & from,///  
		const unsigned __int8 & to,///  
		unsigned __int8 & count,///    
		const struct Position & position ///      
	);

	///---------------------------------------------------------------------------
	///         
	///      
	inline void list_record_special
	(
		struct List & list,///   
		const unsigned __int8 name,///   
		const unsigned __int8 d_m,///  
		unsigned __int8 & count,///    
		const unsigned __int8 & from,///  
		const unsigned __int8 to,///  
		const unsigned __int8 capture///   
	);

	///---------------------------------------------------------------------------
	///     ,         
	///       
	inline void KONTROL_captures_W
	(
		const struct Position & position, ///      
		const unsigned __int8 & from,///   
		const unsigned __int8 & to,///   
		const unsigned __int8 & p,///    
		const unsigned __int8 name_figure///   
	);

	///---------------------------------------------------------------------------
	///     ,         
	///       
	inline void KONTROL_captures_B
	(
		const struct Position & position, ///      
		const unsigned __int8 & from,///   
		const unsigned __int8 & to,///   
		const unsigned __int8 & p,///    
		const unsigned __int8 name_figure///   
	);

	///---------------------------------------------------------------------------
	///     ,    
	///    
	inline void KONTROL_move
	(
		const unsigned __int8 & from,//   
		const unsigned __int8 & to,//   
		const unsigned __int8 & p//    
	);


//////////////////////////////////////////////////////////////////////////////////////
//public:

	///---------------------------------------------------------------------------
	///    (..  )
	__inline __int32 bit_scan_forward_win32
	(
		const unsigned __int64 analyzed_number///      
	);

	///---------------------------------------------------------------------------
	///    (..  )
	__inline __int32 bit_scan_reverse_win32
	(
		const unsigned __int64 analyzed_number///      
	);

};


